--- large project schema

use largeproject;


-- represents the file that the user is requesting.
-- acts as a map between an action name and the
-- file that processes the request.
drop table resource;

create table resource (
    id int unsigned auto_increment,
    name varchar(64) not null,
    filename varchar(128) not null,
    issecure smallint,
    permission varchar(64),
    subject varchar(128),
    primary key(id),
    unique(name)
);

-- user information
drop table userinfo;

create table userinfo (
    id int unsigned auto_increment,
    username varchar(32) not null,
    password varchar(32) not null,
    name varchar(32),
    email varchar(64),
    usersince datetime,
    lastlogin datetime,
    primary key(id),
    unique(username)
);

-- role table
drop table role;

create table role (
    id int unsigned auto_increment,
    name varchar(64),
    primary key(id),
    unique(name)
);


-- role permission
drop table permission;

create table permission (
    id int unsigned auto_increment,
    name varchar(64),
    primary key(id),
    unique(name)
);

-- userrole; link between user and role.
drop table userrole;

create table userrole (
    id int unsigned auto_increment,
    userid int unsigned,
    roleid int unsigned,
    primary key(id)
);

-- rolepermission; link between role and permission
drop table rolepermission;

create table rolepermission (
    id int unsigned auto_increment,
    roleid int unsigned,
    permissionid int unsigned,
    primary key(id)
);

